/***********************************************************************/
/*                           PROPERTY OF THE                           */
/*                CONCURRENT SOFTWARE SYSTEMS LABORATORY               */
/***********************************************************************/
#include "Iterator.h"

/************************************************************************/
/*             ITERATOR OBJECT - TEMPLATE CLASS DEFINITION              */
/************************************************************************/
/************************************************************************/
/*                    DEFAULT CONSTRUCTOR DEFINITION                    */
/************************************************************************/

   template<class Type>
   Iterator<Type>::Iterator()
   {
       iterator = NULL;
       start    = NULL;
   }

/************************************************************************/
/*                   CONSTRUCTOR WITH A LIST ARGUMENT                   */
/************************************************************************/


   template<class Type>
   Iterator<Type>::Iterator(List<Type> &list)
   {
      iterator = list.Head;
      start    =  iterator;
   }
/************************************************************************/
/*                          DEFAULT DESTRUCTOR                          */
/************************************************************************/

  template<class Type>
  Iterator<Type>::~Iterator()
  {
   iterator = NULL;
   start    = NULL;
  }

/************************************************************************/
/*                      MESSAGE First() DEFINITION                      */
/************************************************************************/

  template<class Type>
  Node<Type>*  Iterator<Type>::First()
  {
    return( (iterator = start) );
  }

/************************************************************************/
/*                      MESSAGE Reset() DEFINITION                      */
/************************************************************************/

  template<class Type>
  Node<Type>*  Iterator<Type>::Reset()
  {
    return( (iterator = start) );
  }

/************************************************************************/
/*                      MESSAGE Next() DEFINITION                       */
/************************************************************************/

  template<class Type>
  Node<Type>*  Iterator<Type>::Next()
  {
   iterator = ( iterator == NULL ) ? iterator : iterator->Next;
   return(iterator);
  }

/************************************************************************/
/*                       MESSAGE More() DEFINITION                      */
/************************************************************************/

  template<class Type>
  bool Iterator<Type>::More()
  {
     if(iterator == NULL)
        return(false);
     else
        return(true);
  }

/************************************************************************/
/*                     MESSAGE ShowNode() DEFINITION                    */
/************************************************************************/

  template<class Type>
  void Iterator<Type>::ShowNode()
  {
     cout<<iterator->data<<flush;
  }

/************************************************************************/
/*                    MESSAGE Adjust() DEFINITION                       */
/*      Its operation is the same as the one of the Constructor's.      */
/************************************************************************/

   template<class Type>
   void Iterator<Type>::Adjust(List<Type> &list)
   {
      iterator = list.Head;
      start    =  iterator;
   }

/************************************************************************/
/*                    MESSAGE Adjust() DEFINITION                       */
/* Its operation is the same as the one above,only here the argument is */
/* Node<Type>*, which is should be the Head of a list.                  */
/************************************************************************/

   template<class Type>
   void Iterator<Type>::Adjust(Node<Type> *pN)
   {
      iterator =        pN;
      start    =  iterator;
   }


/************************************************************************/
/*          Concurrent Software Systems Laboratory (c)1995              */
/************************************************************************/














