/***********************************************************************/
/*                           PROPERTY OF THE                           */
/*                CONCURRENT SOFTWARE SYSTEMS LABORATORY               */
/***********************************************************************/
/***********************************************************************/
/*                              Header File                            */
/***********************************************************************/
#ifndef ITERATOR_H_
#define ITERATOR_H_
#include "List.h"

/***********************************************************************/
/*           ITERATOR OBJECT - TEMPLATE CLASS DECLARATION              */
/***********************************************************************/

   template <class Type>
   class Iterator
   {

     public:

                          Iterator();   // Default Constructor.
               Iterator(List<Type>&);   // Constructor from List<Type>.
                         ~Iterator();   // Default Destructor.
      Node<Type>*            First();   // Returns the first Node.
      Node<Type>*            Reset();   // Resets to the Head of the List.
      Node<Type>*             Next();   // Returns the Next Node than current
      bool                    More();   // Returns True if more nodes to come
      void                ShowNode();   // Displays the data of the node.
      void       Adjust(List<Type>&);   // Manual Constructor.
      void       Adjust(Node<Type>*);   // Manual Constructor with Node* arg.


      private:
      Node<Type>           *iterator;   // Successor on the nodes.
      Node<Type>              *start;   // Holds the Head address of the List.
     };

/***********************************************************************/
/*         Concurrent Software Systems Laboratory (c)1995              */
/***********************************************************************/
#endif
