/***********************************************************************/
/*                           PROPERTY OF THE                           */
/*                CONCURRENT SOFTWARE SYSTEMS LABORATORY               */
/***********************************************************************/
/***********************************************************************/
/*                              Header File                            */
/***********************************************************************/
#include <assert.h>
#include <iostream.h>
#include <stdio.h>

#ifndef ENUM_BOOLEAN_
#define ENUM_BOOLEAN_
  enum bool {false, true};
#endif

#ifndef LIST_H_
#define LIST_H_

/*****************************************************************/
/*              NODE OBJECT - TEMPLATE CLASS DEFINITION          */
/*****************************************************************/

	template<class Type>
	class Node
	{
	   public:
		         Node(Type&);
	   Type            getData();
	   Type                 data;
	   Node<Type>          *Next;
	};

/*****************************************************************/
/*        LINKED LIST OBJECT - TEMPLATE CLASS DEFINITION         */
/*****************************************************************/

	template<class Type>
	class List
	{
    	 public:
  			        List();  // Default Constructor.
                           List(Type&);  // Constructor for Type objects.
		     List(List<Type>&);  // Constructor for List objects.
			       ~List();  // Default Destructor.
	 int                 getSize();  // Return the list's size.
	 bool                isEmpty();  // Returns TRUE if an empty list.
	 Node<Type>*         getHead();  // Returns the Head pointer value.
	 Node<Type>*         getTail();  // Returns the Tail pointer value.
	 void                Display();  // Display the list object.
	 void             Deallocate();  // Manual List destructor.

	 bool      Remove(Node<Type>*);  // Remove a node from list.
         bool             Remove(Type);  //       --ditto--
         Type             RemoveHead();

	 List<Type>& operator=(List<Type>&);
	 List<Type>&          Append(Type&);  // Append an element at the end.
	 List<Type>&          Insert(Type&);  // Insert from the front.
         List<Type>& AppendWithoutRepetition(Type&); 
	 friend ostream& operator<<(ostream&, List<Type>&);
	// friend Iterator<Type>;

	// private:
	 Node<Type>                   *Head; // Beggining of structure.
	 Node<Type>                   *Tail; // End of structure.
	 int                           Size; // Current size of the list.

	 Node<Type>*             CreateNode(Type&);
	 Node<Type>*  FindPredecessor(Node<Type>*);
  };

	 template<class Type> ostream& operator<<(ostream&, List<Type>&);
/************************************************************************/
/*          Concurrent Software Systems Laboratory (c)1995              */
/************************************************************************/
#endif






