/********************************************************************/
/*                           PROPERTY OF THE                        */
/*                CONCURRENT SOFTWARE SYSTEMS LABORATORY            */
/********************************************************************/
#include "Trie.h"

/********************************************************************/
/*                    Leaf Class Message Definition                 */
/********************************************************************/
int Leaf::NumberOfProcesses;

Leaf::Leaf(int* Perm_ , int nop) 
{ NumberOfProcesses = nop;
  Perm = new int[NumberOfProcesses];
  memcpy(Perm, Perm_, sizeof(int) * NumberOfProcesses);
  Link = NULL;
}


Leaf::~Leaf()           { }
  
/********************************************************************/
/*                  Trie Class Messsage Definitions                 */
/********************************************************************/

int* Trie::idPrm = NULL;
Trie::Trie(int nop) 
{
  int i;
  int *pi;

  NumberOfProcesses = nop;
  size  = theHashFunction();
  table = new Leaf*[size];
  distr = new int[size];
  pi    = new int[NumberOfProcesses];

  Population = 0;
  maxdistr   = 0;

  for(i=0; i<size; i++) { table[i] = NULL; distr[i] = 0; }
  for(i=0; i<NumberOfProcesses; i++)  pi[i] = i;
  idPrm = Insert(pi);
  delete [] pi;
}

Trie::~Trie()          { } 
int* Trie::getIdPerm() { return( Trie::idPrm ); }
int Trie::getSize()    { return( Population  ); }
int Trie::getmaxdistr()    { return( maxdistr  ); }

int* Trie::Insert(int *perm)
{
  int    i;
  int   *pi;
  int    hashindex;
  Leaf  *pLf;
  Leaf  *Last_pLf; 
  int    flag;
  hashindex = theHashFunction(perm, NumberOfProcesses);

  pLf = table[hashindex];
  if( pLf == NULL )
    { table[hashindex] = new Leaf(perm, NumberOfProcesses);
      distr[hashindex]++;
      Population++;
      return(table[hashindex]->Perm);
    }
  do 
    { 
      if(!memcmp(pLf->Perm,perm,sizeof(int)*NumberOfProcesses)) 
	 return(pLf->Perm); 
      Last_pLf = pLf;
      pLf = pLf->Link;
    } while(pLf != NULL);
  
  Last_pLf->Link = new Leaf(perm, NumberOfProcesses);

  distr[hashindex]++;
  Population++;
  if(maxdistr<distr[hashindex]) 
    maxdistr = distr[hashindex];
  
  return(Last_pLf->Link->Perm);
}



int theHashFunction()
{  static int flag = 1;
   static int hashsize;
   if(flag) { hashsize = 907;
              flag = 0;
	    }
   return(hashsize);
}

int theHashFunction(int *perm, int NumberOfProcesses) 
{ int i;
  int hashsize;
  int ret=0;
 
  hashsize = theHashFunction();
  for(i=0;i<NumberOfProcesses;i++) ret = (ret * 7 + perm[i]) % hashsize;

  return(ret);
}
    

/********************************************************************/
/*           Concurrent Software Systems Laboratory (c)1996         */
/********************************************************************/
