/********************************************************************/
/*                           PROPERTY OF THE                        */
/*                CONCURRENT SOFTWARE SYSTEMS LABORATORY            */
/********************************************************************/
#include   <iostream.h>
#include      <stdio.h>
#include     <memory.h>
#include     "time.h"

/********************************************************************/
/*                            Header File                           */
/********************************************************************/

#ifndef ENUM_BOOLEAN_
#define ENUM_BOOLEAN_
 enum bool {false,true};
#endif

/********************************************************************/
/*                        Leaf Class Declaration                    */
/********************************************************************/
#ifndef LEAF_H_
#define LEAF_H_

class Leaf
  {  public:          Leaf(int*, int);             
                     ~Leaf();
           
     Leaf           * Link;  
     int            * Perm; 
     static int       NumberOfProcesses;
  }; 

/********************************************************************/
/*                      Trie Class Definition                       */
/********************************************************************/
/* This object will be used to store in its leaves any Permutations */
/* created during the execution of the State Equivalence algorithms.*/
/* The class is ment to save us memory space, since now one copy of */
/* every unique Permutation will exist in the program.              */
/* All permutation references refer to a specific/unique path on the*/
/* data structure. This Trie class accepts as key an array of ints. */
/********************************************************************/

class Trie 
  {
     public:      Trie(int);
		 ~Trie();
     int*         Insert(int*);
     int*         getIdPerm();
     int          getSize();
     int          getmaxdistr();

     private:
     int                NumberOfProcesses;
     Leaf             **table;         // the hash table
     int               *distr;         // the distribution on the hash table
     int                maxdistr;
     int                size;          // its size
     static int        *idPrm;          
     int                Population;
     
  };

int theHashFunction(int *,int); 
int theHashFunction();
  
#endif

/********************************************************************/
/*           Concurrent Software Systems Laboratory (c)1996         */
/********************************************************************/
