Program 
Module client = 2;
Module bus    = 1;


// EVENTS:

LR[client] = 0; // ?LK_DATA.req
LP[client] = 0; // ?LK_DATA.resp
LC[client] = 0; // !LK_DATA.conf
LI[client] = 0; // !LK_DATA.ind
PA[client] = 0; // !PH_ARB.req
PR[client] = 0; // !PH_DATA.req
PC[client] = 0; // ?PH_ARB.conf
PI[client] = 0; // ?PH_DATA.ind

// DATA PARAMETERS:

lr[client] = 0; // for ?LK_DATA.req
li[client] = 0; // for !LK_DATA.ind
pr[client] = 0; // for !PH_DATA.req
pi[client] = 0; // for ?PH_DATA.ind
 

// TRANSACTION LAYER INTERNAL VARS:

TS[client] = 0; // TRANSACTION_STATE

// LINK LAYER INTERNAL VARS:

KS[client] = 0; // LINK_STATE
ks[client] = 0; // internal variable 
kd[client] = 0; // internal variable 

// PHYSICAL LAYER INTERNAL VARS:

BS[]       = 0; // PHYSICAL_STATE
// ba[client] = 0; // internal variable: the served client

// TRANSACTION LAYER TRANSITIONS:
c of client: 
{
// setting a ?LK_DATA.req signal

LR[c] == 0 & TS[c] == 0 ->
	LR[c] = 1, lr[c] = 0, TS[c] = 3;
LR[c] == 0 & TS[c] == 0 ->
	LR[c] = 1, lr[c] = 1, TS[c] = 3;
LR[c] == 0 & TS[c] == 0 ->
	LR[c] = 2, lr[c] = 0, TS[c] = 3;
LR[c] == 0 & TS[c] == 0 ->
	LR[c] = 2, lr[c] = 1, TS[c] = 3;

LR[c] == 0 & TS[c] == 2 ->
	LR[c] = 2, lr[c] = 0, TS[c] = 3;
LR[c] == 0 & TS[c] == 2 ->
	LR[c] = 2, lr[c] = 1, TS[c] = 3;

// setting a ?LK_DATA.resp signal

LP[c] == 0 & TS[c] == 1 ->
	LP[c] = 1, TS[c] = 2;

LP[c] == 0 & TS[c] == 1 ->
	LP[c] = 2, TS[c] = 0;

LP[c] == 0 & TS[c] == 5 ->
	LP[c] = 3, TS[c] = 0;

// receiving !LK_DATA.conf
 
LC[c]  > 0 & TS[c] == 3 ->
	LC[c] = 0, TS[c] = 0;

// receiving !LK_DATA.ind
 
LI[c] == 1 & TS[c] == 0 ->
	LI[c] = 0, li[c] = 0, TS[c] = 1; 

LI[c]  > 1 & TS[c] == 0 ->
	LI[c] = 0, li[c] = 0, TS[c] = 5; 
}

// LINK LAYER TRANSITIONS:
c:
{ 
// sending a message

KS[c] == 0 & LR[c] > 0 & PA[c] == 0 ->
	KS[c] = 1, LR[c] = 0, lr[c] = 0, PA[c] = 2,
        ks[c] = LR[c], kd[c] = lr[c];

KS[c] == 1 & PC[c] == 2 & LC[c] == 0 ->
	KS[c] = 0, PC[c] = 0, LC[c] = 4,
	ks[c] = 0, kd[c] = 0;

KS[c] == 1 & PC[c] == 1 & PR[c] == 0 ->
	KS[c] = 2, PC[c] = 0, PR[c] = ks[c], pr[c] = kd[c],
	kd[c] = 0;

KS[c] == 2 & ks[c] == 1 & LC[c] == 0 ->
	KS[c] = 0, ks[c] = 0, LC[c] = 3;

KS[c] == 2 & ks[c] == 2 & PI[c] == 4 & LC[c] == 0 ->
	KS[c] = 0, ks[c] = 0, PI[c] = 0, pi[c] = 0, LC[c] = 2;

KS[c] == 2 & ks[c] == 2 & PI[c]  > 0 ->
	KS[c] = 3, ks[c] = PI[c], PI[c] = 0, pi[c] = 0;

KS[c] == 3 & ks[c] <> 5 & LC[c] == 0 ->
	KS[c] = 0, ks[c] = 0, LC[c] = 2;

KS[c] == 3 & ks[c] == 5 & LC[c] == 0 ->
	KS[c] = 0, ks[c] = 0, LC[c] = 1;


// receiving message

KS[c] == 0 & PI[c] == 1 & LI[c] == 0 ->
	KS[c] = 0, PI[c] = 0, pi[c] = 0, LI[c] = 2;

KS[c] == 0 & PI[c] == 3 ->
	KS[c] = 0, PI[c] = 0, pi[c] = 0;

KS[c] == 0 & PI[c] == 4 -> 
	KS[c] = 0, PI[c] = 0, pi[c] = 0;

KS[c] == 0 & PI[c] == 2 & PA[c] == 0 ->
	KS[c] = 4, PI[c] = 0, pi[c] = 0, PA[c] = 1, 
	kd[c] = pi[c];

KS[c] == 4 & PC[c] == 1 & LI[c] == 0 ->
	KS[c] = 5, PC[c] = 0, LI[c] = 1, li[c] = kd[c],
	kd[c] = 0;

KS[c] == 5 & LP[c] == 0 & PR[c] == 0 ->
	KS[c] = 5, PR[c] = 5;

KS[c] == 5 & LP[c] == 2 & PR[c] == 0 ->
	KS[c] = 0, LP[c] = 0, PR[c] = 4;

KS[c] == 5 & LP[c] == 1 & PR[c] == 0 ->
	KS[c] = 7, LP[c] = 0, PR[c] = 3;

KS[c] == 7 & PR[c] == 0 ->
	KS[c] = 0, PR[c] = 6;

KS[c] == 7 & LR[c] == 2 & PR[c] == 0 ->
	KS[c] = 2, LR[c] = 0, lr[c] = 0, PR[c] = 2, pr[c] = lr[c],
	ks[c] = 2;
}

k of client;
l of client;

b of bus:
{
// arbitration

BS[] == 0 & PA[c] == 1 & PC[c] == 0 ->
	BS[] = 1, PA[c] = 0, PC[c] = 1;

BS[] == 0 & PA[c] == 2 & PC[c] == 0 & ALL(k: c == k | PA[k] <> 1) ->
	BS[] = 1, PA[c] = 0, PC[c] = 1;
 
BS[] == 1 & PA[c] == 2 & PC[c] == 0 ->
	BS[] = 1, PA[c] = 0, PC[c] = 2;

// transmission of packedges

BS[] == 1 & PR[c] == 1 & ALL(k: c == k | PI[k] == 0) ->
	BS[] = 0, PR[c] = 0, pr[c] = 0,
	ALL(k: PI[k] = 1, pi[k] = pr[c]),
	PI[c] = PI[c], pi[c] = pi[c]; 

BS[] == 1 & PR[c] == 2 & ALL(k: c == k | PI[k] == 0) & c <> l ->
	BS[] = 0, PR[c] = 0, pr[c] = 0,
	ALL(k: PI[k] = 3, pi[k] = pr[c]),
	PI[c] = PI[c], pi[c] = pi[c],
	PI[l] = 2;

BS[] == 1 & PR[c] == 3 & ALL(k: c == k | PI[k] == 0) ->
	BS[] = 1, PR[c] = 0, pr[c] = 0,
	ALL(k: PI[k] = 5),
	PI[c] = PI[c]; 

BS[] == 1 & PR[c] == 4 & ALL(k: c == k | PI[k] == 0) ->
	BS[] = 0, PR[c] = 0, pr[c] = 0,
	ALL(k: PI[k] = 5),
	PI[c] = PI[c]; 

BS[] == 1 & PR[c] == 5 ->
	BS[] = 1, PR[c] = 0, pr[c] = 0;

BS[] == 1 & PR[c] == 6 ->
	BS[] = 0, PR[c] = 0, pr[c] = 0;

// error generation in BCST message

BS[] == 1 & PR[c] == 1 & ALL(k: c == k | PI[k] == 0) ->
	BS[] = 0, PR[c] = 0, pr[c] = 0,
	ALL(k: PI[k] = 4),
	PI[c] = PI[c]; 

// error generation in NBCST message

BS[] == 1 & PR[c] == 2 & ALL(k: c == k | PI[k] == 0) ->
	BS[] = 0, PR[c] = 0, pr[c] = 0,
	ALL(k: PI[k] = 4),
	PI[c] = PI[c];
	
// error generation in ACK message

BS[] == 1 & PR[c] == 3 & ALL(k: c == k | PI[k] == 0) ->
	BS[] = 1, PR[c] = 0, pr[c] = 0,
	ALL(k: PI[k] = 4),
	PI[c] = PI[c]; 

BS[] == 1 & PR[c] == 4 & ALL(k: c == k | PI[k] == 0) ->
	BS[] = 0, PR[c] = 0, pr[c] = 0,
	ALL(k: PI[k] = 4),
	PI[c] = PI[c]; 
}



/*Module dl = 1;
dl[dl] = 0;
d of dl:{ dl[d] == 0 -> dl[d] = 1; dl[d] == 1 -> dl[d] = 0;}
Automata
InitialState s;
FinalState f1;
True ->s:s;
True ->s:f0;
dl[0] == 0 -> f0:f1;
dl[0] == 1 -> f1:f0;
*/ 

/* found deadlock after 1525 AQS states:
LR0 LR0 LP0 LP3 LC0 LC0 LI0 LI2 
PA0 PA0 PR2 PR0 PC0 PC0 PI0 PI1 
lr0 lr0 li0 li0 pr0 pr0 pi0 pi1 
TS3 TS5 
KS2 KS0 ks2 ks0 kd0 kd0 
BS1 ba1 ba0 
*/